/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

long inv_mod(long a,long p) {
  long q,r0,r1,r2,s0,s1,s2,t0,t1,t2;
  r0 = p; r1 = a;
  s0 = 1; s1 = 0;
  t0 = 0; t1 = 1;
  for( ; r1 != 0 ; ) {
    q = r0 / r1;
    r2 = r0 - q * r1;
    s2 = s0 - q * s1;
    t2 = t0 - q * t1;
    r0 = r1; r1 = r2;
    s0 = s1; s1 = s2;
    t0 = t1; t1 = t2;
  }
  if ( t0 > 0 ) return t0 % p;
  return p - ((-t0) % p);
}

unsigned long char2_word_reduce(unsigned long a,
                                unsigned long mod,
                                uma deg)
{
  uma i;
  for( i = 2 * deg - 2 ; i >= deg ; i-- ) {
    a ^= (mod & (-((a >> i) & 1))) << (i - deg);
  }
  return a;
}

