/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/* generic/kronecker.c */
void ll_get_mask_1(mp_limb_t*,uma);
void ll_get_mask_n(mp_limb_t*,uma);
void ll_mpn_and_n(mp_limb_t*,mp_limb_t*,uma);

/* generic/memory.c */
void *ll_malloc(uma);
void *ll_realloc(void*,uma);
void *ll_calloc(uma);
void ll_free(void*);

/* generic/random.c */
void ll_random_seed(unsigned long);
unsigned long ll_random(void);

/* generic/modular.c */
long inv_mod(long,long);
unsigned long char2_word_reduce(unsigned long,unsigned long,uma);

/* generic/critical.c */
void __crit_common_check(uma,uma,const char*,long);
uma __crit_add(uma,uma,const char*,long);
uma __crit_sub(uma,uma,const char*,long);
uma __crit_mul(uma,uma,const char*,long);
uma __crit_div(uma,uma,const char*,long);

