/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
*/

void ll_binomial(R r,uma n,uma k) {
#ifdef RING_CHAR2
  unsigned long un,uk,bin;
  un = __CAST(unsigned long,n);
  uk = __CAST(unsigned long,k);
  /* Intellectual masturbation: fucking useless !!!!!
     A simple ``if" is sufficient !!!!! */
  bin = (un | (~uk)) + 1;
  bin = ~((-bin) | bin);
  bin >>= (__SZ(unsigned int) - 1);
  R_castint(r,__CAST(int,bin));
#else
#ifdef RING_CHAR_UMA
  switch(k) {
    case 1:
      R_castint(r,n);
      break;
    default: {
      unsigned long un,uk;
      mpz_t tmp;
      un = __CAST(unsigned long,n);
      uk = __CAST(unsigned long,k);
      mpz_init(tmp);
      mpz_bin_uiui(tmp,un,uk);
      R_cast_integer(r,tmp);
      mpz_clear(tmp);
      break;
    }
  }
#else
  (void)r;
  (void)n;
  (void)k;
#endif
#endif
}

