/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_dbpol_eval(R z,R *a,uma nax,uma nay,R x,R y);`
  Evaluate `a` of size (`nax`,`nay`) at (`x`,`y`).
*/

void ll_dbpol_eval(R z,R *a,uma nax,uma nay,R x,R y) {
  ll_dbpol_eval_horner(z,a,nax,nay,x,y);
}

/**
> `void ll_dbpol_horner_upol(R *r,uma *nr,R *a,uma nax,uma nay\
  ,R *b,uma nb);`
  Evaluate `a` of size (`nax`,`nay`) at `b` of size `nb`.
*/

void ll_dbpol_eval_upol(R *r,uma *nr,
                        R *a,uma nax,uma nay,R *b,uma nb)
{
  ll_dbpol_eval_horner_upol(r,nr,a,nax,nay,b,nb);
}

