/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_dbpol_mul_by_Y(R *r,R *a,uma nax,uma nay);`
  Set `r` to `a * Y` where `a` has size (`nax`,`nay`).
  You can have `r == a`.
*/

void ll_dbpol_mul_by_Y(R *r,R *a,uma nax,uma nay) {
  uma i;
  for( i = nax * nay - nax ; i >= 0 ; i -= nax ) {
    ll_vec_copy(&r[i + nax],&a[i],nax);
  }
  ll_vec_zero(r,nax);
}

/**
> `void ll_dbpol_mul_by_Yn(R *r,R *a,uma nax,uma nay,uma n);`
  Set `r` to `a * Y^n` where `a` has size (`nax`,`nay`).
  You can have `r == a`.
*/

void ll_dbpol_mul_by_Yn(R *r,R *a,uma nax,uma nay,uma n) {
  uma i,tmp;
  tmp = n * nax;
  for( i = nax * nay - nax ; i >= 0 ; i -= nax ) {
    ll_vec_copy(&r[i + tmp],&a[i],nax);
  }
  ll_vec_zero(r,tmp);
}

