/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_dbpol_mul_by_affine(R *r,R *a,uma nax,uma nay,R b);`
  Set `r` to `a * (Y + b)` where `a` has size (`nax`,`nay`).
  You can have `r == a`.
*/

void ll_dbpol_mul_by_affine(R *r,R *a,uma nax,uma nay,R b) {
  uma i,n1,n2;
  if ( r == a ) {
    R *buf[2];
    uma curr,prev,j0,j1,tmp;
    buf[0] = ll_vec_malloc_copy(r,nax);
    ll_vec_mul_by_cte(r,r,nax,b);
    buf[1] = ll_vec_malloc_init(nax);
    prev = 0;
    curr = 1;
    for( i = 1 ; i < nay ; i++ ) {
      n1 = i * nax;
      n2 = n1 + nax;
      for( j0 = n1,j1 = 0 ; j0 < n2 ; j0++,j1++ ) {
        R_copy(buf[curr][j1],r[j0]);
        R_mul(r[j0],r[j0],b);
        R_add(r[j0],r[j0],buf[prev][j1]);
      }
      tmp = prev;
      prev = curr;
      curr = tmp;
    }
    ll_vec_copy(&r[nax * nay],buf[prev],nax);
    ll_vec_free(buf[0],nax);
    ll_vec_free(buf[1],nax);
  }
  else {
    uma j;
    ll_vec_mul_by_cte(r,a,nax,b);
    for( i = 1 ; i < nay ; i++ ) {
      n1 = i * nax;
      n2 = n1 + nax;
      for( j = n1 ; j < n2 ; j++ ) {
        R_copy(r[j],a[j - nax]);
        R_add_mul(r[j],a[j],b);
      }
    }
    ll_vec_copy(&r[nax * nay],&a[(nay - 1) * nax],nax);
  }
}

