/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_dbpol_mul_by_upolX(R *r,R *a,uma nax,uma nay,R *b,\
  uma nbx);`
  Set `r` to `a * b` where `a` has size (`nax`,`nay`).
*/

void ll_dbpol_mul_by_upolX(R *r,R *a,uma nax,uma nay,R *b,uma nbx) {
  uma i,nrx;
  nrx = nax + nbx - 1;
  for( i = 0 ; i < nay ; i++ ) {
    ll_upol_mul(&r[i * nrx],&a[i * nax],nax,b,nbx);
  }
}

/**
> `void ll_dbpol_mul_by_upolY(R *r,R *a,uma nax,uma nay,\
  R *b,uma nby)`
  Set `r` to `a(X,Y) * b(Y)` where `a` has size (`nax`,`nay`)
  and `b` must be represented as univariate polynomial of size `nby`.
*/

void ll_dbpol_mul_by_upolY(R *r,R *a,uma nax,uma nay,R *b,uma nby) {
  ll_dbpol_mul(r,a,nax,nay,b,1,nby);
}

