/*
 * This file is part of decoding
 * Copyright 2013  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `int ll_upol_iszero(R *a,uma na);`
  Return nonzero if and only if `na = 1` and `a[0] = 0`.
  Note that if the degree of `a` is `na - 1` this function returns
  nonzero if and only if `a` with size `na` is the zero polynomial.
*/

int ll_upol_iszero(R *a,uma na) {
  if ( na == 1 && R_iszero(a[0]) ) return -1;
  return 0;
}

