/*
 * This file is part of decoding
 * Copyright 2013  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_upol_derivative_naive(R *r,R *a,uma na);`
  Set `r` to be the formal derivative of `a` of size `na`.
  The naive algorithm is used.
*/

void ll_upol_derivative_naive(R *r,R *a,uma na) {
  uma i;
  R coeff;
  R_init(coeff);
  for( i = 0 ; i < (na - 1) ; i++ ) {
    R_castuma(coeff,i + 1);
    R_mul(r[i],coeff,a[i + 1]);
  }
  R_clear(coeff);
}

/**
> `void ll_upol_derivative(R *r,R *a,uma na);`
  Set `r` to be the formal derivative of `a` of size `na`.
*/

void ll_upol_derivative(R *r,R *a,uma na) {
#ifdef MY_UPOL_DERIVATIVE
  MY_UPOL_DERIVATIVE(r,a,na);
#else
  ll_upol_derivative_naive(r,a,na);
#endif
}

