/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_upol_div_by_affine(R *r,R *a,uma na,R b);`
  Set `r` to the quotient of the Euclidean division of
  `a` by `X + b` where `a` has size `na`.
*/

void ll_upol_div_by_affine(R *r,R *a,uma na,R b) {
#ifdef MY_UPOL_DIV_BY_AFFINE
  MY_UPOL_DIV_BY_AFFINE(r,a,na,b);
#else
  R *tmp;
  uma i,ntmp;
  ntmp = na;
  tmp = ll_vec_malloc_copy(a,na);
  for( i = na - 1 ; i >= 1 ; i-- ) {
    R_copy(r[i - 1],tmp[i]);
    R_sub_mul(tmp[i - 1],b,tmp[i]);
    R_zero(tmp[i]);
  }
  ll_vec_free(tmp,ntmp);
#endif
}

