/*
 * This file is part of decoding
 * Copyright 2013  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_upol_eea(R *gcd,uma *ngcd,R *u,uma *nu,R *v,uma *nv,\
R *a,uma na,R *b,uma nb);`
  Set `gcd` of size `ngcd`, `u` of size `nu` and `v` of size `nv`
  to be the GCD and the Bezout coefficients of `a` of size `na`
  and `b` of size `nb`. Namely it returns `gcd`, `u` and `v`
  such that `u(X) a(X) + v(X) b(X) = gcd(X)`.
  Note that `u` must point to a region of at least `nb` allocated
  `R`'s and `v` must point to a region of at least `na` allocated
  `R`'s.
*/

void ll_upol_eea(R *gcd,uma *ngcd,R *u,uma *nu,R *v,uma *nv,
                 R *a,uma na,R *b,uma nb)
{
#ifdef MY_UPOL_EEA
  MY_UPOL_EEA(gcd,ngcd,u,nu,v,nv,a,na,b,nb);
#else
  ll_upol_partial_eea_naive(gcd,ngcd,u,nu,v,nv,a,na,b,nb,-1);
#endif
}

