/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_upol_eval(R r,R *a,uma na,R x);`
  Set `r` to be `a(x)` where `a` is a univariate polynomial
  of size `na`.
*/

void ll_upol_eval(R r,R *a,uma na,R x) {
#ifdef MY_UPOL_EVAL
  MY_UPOL_EVAL(r,a,na,x);
#else
  ll_upol_eval_horner(r,a,na,x);
#endif
}

/**
> `void ll_upol_multi_eval(R *r,R *a,uma na,R *b,uma nb);`
  Set `r` such that `r[i]` is `a(b[i])` where `a` is a
  univariate polynomial of size `na` and `b` is a vector
  of size `nb`.
*/

void ll_upol_multi_eval(R *r,R *a,uma na,R *b,uma nb) {
#ifdef MY_UPOL_MULTI_EVAL
  MY_UPOL_MULTI_EVAL(r,a,na,b,nb);
#else
  ll_upol_multi_eval_horner(r,a,na,b,nb);
#endif
}

