/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_upol_mul_by_X(R *r,R *a,uma na);`
  Set `r` to be `a(X) * X` where `a` has size `na`.
  You can have `r == a`.
*/

void ll_upol_mul_by_X(R *r,R *a,uma na) {
  uma i;
  for( i = na - 1 ; i >= 0 ; i-- ) {
    R_copy(r[i + 1],a[i]);
  }
  R_zero(r[0]);
}

/**
> `void ll_upol_mul_by_Xn(R *r,R *a,uma na,uma n);`
  Set `r` to be `a(X) * X^n` where `a` has size `na`.
  You can have `r == a`.
*/

void ll_upol_mul_by_Xn(R *r,R *a,uma na,uma n) {
  uma i;
  for( i = na - 1 ; i >= 0 ; i-- ) {
    R_copy(r[i + n],a[i]);
  }
  ll_vec_zero(r,n);
}

