/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_upol_print(FILE *out,R *a,uma na);`
  Pruma into `out` the univariate polynomial `a` of size `na`.
*/

void ll_upol_print(FILE *out,R *a,uma na) {
  uma i;
  for( i = 0 ; i < na && R_iszero(a[i]) ; i++ );
  if ( i >= na ) {
    fputc('0',out);
    return;
  }
  R_print(out,a[i]);
  if ( i == 1 ) fputs("*X",out);
  if ( i > 1 ) fprintf(out,"*X^%ld",__CAST(long,i));
  for( i++ ; i < na ; i++ ) {
    if ( !R_iszero(a[i]) ) {
      fputs(" + ",out);
      R_print(out,a[i]);
      if ( i == 1 ) fputs("*X",out);
      if ( i > 1 ) fprintf(out,"*X^%ld",__CAST(long,i));
    }
  }
}

