/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_upol_random(R *r,uma nr);`
  Set `r` to be a random polynomial of size `nr`.
  The resulting polynomial will have degree `nr - 1`.
  If you do not require this property prefer
  `ll_vec_random` instead.
*/

void ll_upol_random(R *r,uma nr) {
  ll_vec_random(r,nr);
  if ( R_iszero(r[nr - 1]) ) R_castint(r[nr - 1],1);
}

/**
> `R *ll_upol_malloc_random(uma nr);`
  Return a pointer to a random polynomial of size `nr`.
  The resulting polynomial will have degree `nr - 1`.
  If you do not require this property prefer
  `ll_vec_malloc_random` instead.
*/

R *ll_upol_malloc_random(uma nr) {
  R *r;
  r = ll_vec_malloc_random(nr);
  if ( R_iszero(r[nr - 1]) ) R_castint(r[nr - 1],1);
  return r;
}

