/*
 * This file is part of decoding
 * Copyright 2013  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_vec_prod_naive(R *r,R *a,uma na);`
  Set `r` to be the product of all the components of `a` of size `na`.
  The dichotomy algorithm is used.
*/

void ll_vec_prod_naive(R r,R *a,uma na) {
  R r1,r2;
  uma na1,na2;

  if ( na <= 2 ) {
    switch(na) {
      case 0:
        R_copy(r,R_one);
        return;
      case 1:
        R_copy(r,a[0]);
        return;
      case 2:
        R_mul(r,a[0],a[1]);
        return;
    }
  }
  R_inits(r1,r2,NULL);
  na1 = na / 2;
  na2 = na - na1;
  ll_vec_prod_naive(r1,a,na1);
  ll_vec_prod_naive(r2,&a[na1],na2);
  R_mul(r,r1,r2);
  R_clears(r1,r2,NULL);
}

/**
> `void ll_vec_prod_naive(R *r,R *a,uma na);`
  Set `r` to be the product of all the components of `a` of size `na`.
*/

void ll_vec_prod(R r,R *a,uma na) {
#ifdef MY_VEC_PROD
  MY_VEC_PROD(r,a,na);
#else
  ll_vec_prod_naive(r,a,na);
#endif
}

