/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/* structs */
#define ll_upol_shift_fast_pc __C(R,_ll_upol_shift_fast_pc)
#define ll_upol_shift_car2_pc __C(R,_ll_upol_shift_car2_pc)
#define ll_dbpol_shift_fast_pc __C(R,_ll_dbpol_shift_fast_pc)
#define ll_dbpol_shift_car2_pc __C(R,_ll_dbpol_shift_car2_pc)
#define ll_vec_lili __C(R,_ll_vec_lili)
#define ll_upol_prod_tree __C(R,_ll_upol_prod_tree )

/* labels */
#define ll_dbpol_Xroots_rec_free_q __C(R,_ll_dbpol_Xroots_rec_free_q)
#define ll_dbpol_Xroots_rec_free_z0 __C(R,_ll_dbpol_Xroots_rec_free_z0)
#define ll_koetter_single_free_stuff __C(R,_ll_koetter_single_free_stuff)
#define ll_koetter_multi_free_stuff __C(R,_ll_koetter_multi_free_stuff)
#define ll_upol_squarefree_free_disc __C(R,_ll_upol_squarefree_free_disc)
#define ll_upol_squarefree_free_buf __C(R,_ll_upol_squarefree_free_buf) 

/* low level functions */

/* lowlevels/array.c */
#define ll_array_add __C(R,_ll_array_add)
#define ll_array_sub __C(R,_ll_array_sub)
#define ll_array_add_mul_by_cte __C(R,_ll_array_add_mul_by_cte)

/* lowlevels/dbpol_eval_horner.c */
#define ll_dbpol_eval_horner __C(R,_ll_dbpol_eval_horner)
#define ll_dbpol_eval_horner_upol __C(R,_ll_dbpol_eval_horner_upol)

/* lowlevels/dbpol_mul_by_affine.c */
#define ll_dbpol_mul_by_affine __C(R,_ll_dbpol_mul_by_affine)

/* lowlevels/dbpol_mul_by_upol.c */
#define ll_dbpol_mul_by_upolX __C(R,_ll_dbpol_mul_by_upolX)
#define ll_dbpol_mul_by_upolY __C(R,_ll_dbpol_mul_by_upolY)

/* lowlevels/dbpol_mul_by_Y.c */
#define ll_dbpol_mul_by_Y __C(R,_ll_dbpol_mul_by_Y)
#define ll_dbpol_mul_by_Yn __C(R,_ll_dbpol_mul_by_Yn)

/* lowlevels/dbpol_mul.c */
#define ll_dbpol_mul __C(R,_ll_dbpol_mul)
#define ll_dbpol_mul_naive __C(R,_ll_dbpol_mul_naive)

/* lowlevels/dbpol_print.c */
#define ll_dbpol_print_factorized __C(R,_ll_dbpol_print_factorized)

/* lowlevels/dbpol_replace_X_by_XY.c */
#define ll_dbpol_replace_X_by_XYn __C(R,_ll_dbpol_replace_X_by_XYn)

/* lowlevels/dbpol_shift.c */
#define ll_dbpol_shift __C(R,_ll_dbpol_shift)
#define ll_dbpol_shift_naive __C(R,_ll_dbpol_shift_naive)

/* lowlevels/dbpol_shift_fast.c */
#define ll_dbpol_shift_car2 __C(R,_ll_dbpol_shift_car2)
#define ll_dbpol_shift_car22 __C(R,_ll_dbpol_shift_car22)
#define ll_dbpol_shift_car2_finish __C(R,_ll_dbpol_shift_car2_finish)
#define ll_dbpol_shift_car2_prepare __C(R,_ll_dbpol_shift_car2_prepare)
#define ll_dbpol_shift_car2_rec __C(R,_ll_dbpol_shift_car2_rec)
#define ll_dbpol_shift_fast __C(R,_ll_dbpol_shift_fast)
#define ll_dbpol_shift_fast2 __C(R,_ll_dbpol_shift_fast2)
#define ll_dbpol_shift_fast_finish __C(R,_ll_dbpol_shift_fast_finish)
#define ll_dbpol_shift_fast_prepare __C(R,_ll_dbpol_shift_fast_prepare)
#define ll_dbpol_shift_fast_rec __C(R,_ll_dbpol_shift_fast_rec)

/* lowlevels/dbpol_shift_in_X.c */
#define ll_dbpol_shift_in_X __C(R,_ll_dbpol_shift_in_X)

/* lowlevels/dbpol_Xroots.c */
#define ll_dbpol_Xroots __C(R,_ll_dbpol_Xroots)
#define ll_dbpol_Xroots_rec __C(R,_ll_dbpol_Xroots_rec)

/* lowlevels/koetter.c */
#define ll_koetter_multi __C(R,_ll_koetter_multi)
#define ll_koetter_single __C(R,_ll_koetter_single)

/* lowlevels/koetter_shift.c */
#define ll_koetter_shift_multi __C(R,_ll_koetter_shift_multi)
#define ll_koetter_shift_single __C(R,_ll_koetter_shift_single)

/* lowlevels/koetter_shift_omp.c */
#define ll_koetter_shift_omp_single __C(R,_ll_koetter_shift_omp_single)
#define ll_koetter_shift_omp_multi __C(R,_ll_koetter_shift_omp_multi)

/* lowlevels/koetter_sudan.c */
#define ll_koetter_sudan __C(R,_ll_koetter_sudan)

/* lowlevels/koetter_sudan_omp.c */
#define ll_koetter_sudan_omp __C(R,_ll_koetter_sudan_omp)

/* lowlevels/linked_list_vec.c */
#define ll_vec_lili_list_free __C(R,_ll_vec_lili_list_free)
#define ll_vec_lili_node_attach_after __C(R,_ll_vec_lili_node_attach_after)
#define ll_vec_lili_node_attach_before __C(R,_ll_vec_lili_node_attach_before)
#define ll_vec_lili_node_detach __C(R,_ll_vec_lili_node_detach)
#define ll_vec_lili_node_free __C(R,_ll_vec_lili_node_free)
#define ll_vec_lili_node_malloc __C(R,_ll_vec_lili_node_malloc)
#define ll_vec_lili_node_malloc_copy __C(R,_ll_vec_lili_node_malloc_copy)
#define ll_vec_lili_list_in __C(R,_ll_vec_lili_list_in)

/* lowlevels/mat.c */
#define ll_mat_copy __C(R,_ll_mat_copy)
#define ll_mat_free __C(R,_ll_mat_free)
#define ll_mat_malloc_init __C(R,_ll_mat_malloc_init)
#define ll_mat_malloc_random __C(R,_ll_mat_malloc_random)
#define ll_mat_transpose __C(R,_ll_mat_transpose)
#define ll_mat_print __C(R,_ll_mat_print)
#define ll_mat_put __C(R,_ll_mat_put)

/* lowlevels/print.c */
#define ll_print __C(R,_ll_print)

/* lowlevels/upol_eucldiv.c */
#define ll_upol_quo __C(R,_ll_upol_quo)
#define ll_upol_quo_naive __C(R,_ll_upol_quo_naive)
#define ll_upol_quorem __C(R,_ll_upol_quorem)
#define ll_upol_quorem_naive __C(R,_ll_upol_quorem_naive)
#define ll_upol_rem __C(R,_ll_upol_rem)
#define ll_upol_rem_naive __C(R,_ll_upol_rem_naive)

/* lowlevels/upol_gcd.c */
#define ll_upol_gcd __C(R,_ll_upol_gcd)
#define ll_upol_gcd_naive __C(R,_ll_upol_gcd_naive)

/* lowlevels/upol_eval_horner.c */
#define ll_upol_eval_horner __C(R,_ll_upol_eval_horner)
#define ll_upol_multi_eval_horner __C(R,_ll_upol_multi_eval_horner)

/* lowlevels/upol_mul_by_affine.c */
#define ll_upol_mul_by_affine __C(R,_ll_upol_mul_by_affine)

/* lowlevels/upol_mul_by_X.c */
#define ll_upol_mul_by_X __C(R,_ll_upol_mul_by_X)
#define ll_upol_mul_by_Xn __C(R,_ll_upol_mul_by_Xn)

/* lowlevels/upol_mul.c */
#define ll_upol_mul __C(R,_ll_upol_mul)
#define ll_upol_mul_naive __C(R,_ll_upol_mul_naive)

/* lowlevels/upol_normalize.c */
#define ll_upol_normalize __C(R,_ll_upol_normalize)

/* lowlevels/upol_print.c */
#define ll_upol_print __C(R,_ll_upol_print)

/* lowlevels/upol_random.c */
#define ll_upol_malloc_random __C(R,_ll_upol_malloc_random)
#define ll_upol_random __C(R,_ll_upol_random)

/* lowlevels/upol_roots.c */
#define ll_upol_roots __C(R,_ll_upol_roots)

/* lowlevels/upol_shift.c */
#define ll_upol_shift __C(R,_ll_upol_shift)
#define ll_upol_shift_naive __C(R,_ll_upol_shift_naive)

/* lowlevels/upol_shift_fast.c */
#define ll_upol_shift_car2 __C(R,_ll_upol_shift_car2)
#define ll_upol_shift_car22 __C(R,_ll_upol_shift_car22)
#define ll_upol_shift_car2_finish __C(R,_ll_upol_shift_car2_finish)
#define ll_upol_shift_car2_prepare __C(R,_ll_upol_shift_car2_prepare)
#define ll_upol_shift_car2_rec __C(R,_ll_upol_shift_car2_rec)
#define ll_upol_shift_fast __C(R,_ll_upol_shift_fast)
#define ll_upol_shift_fast2 __C(R,_ll_upol_shift_fast2)
#define ll_upol_shift_fast_finish __C(R,_ll_upol_shift_fast_finish)
#define ll_upol_shift_fast_prepare __C(R,_ll_upol_shift_fast_prepare)
#define ll_upol_shift_fast_rec __C(R,_ll_upol_shift_fast_rec)

/* lowlevels/upol_square.c */
#define ll_upol_square __C(R,_ll_upol_square)
#define ll_upol_square_naive __C(R,_ll_upol_square_naive)

/* lowlevels/upol_kronecker_modn_word.c */
#define ll_upol_mul_kronecker_modn_word_encode \
        __C(R,_ll_upol_mul_kronecker_modn_word_encode)
#define ll_upol_mul_kronecker_modn_word_decode \
        __C(R,_ll_upol_mul_kronecker_modn_word_decode)
#define ll_upol_mul_kronecker_modn_word \
        __C(R,_ll_upol_mul_kronecker_modn_word)

/* lowlevels/utils.c */
#define ll_die __C(R,_ll_die)
#define ll_put_word_into_mp_limb __C(R,_ll_put_word_into_mp_limb)
#define ll_get_word_from_mp_limb_1 __C(R,_ll_get_word_from_mp_limb_1)
#define ll_get_word_from_mp_limb_n __C(R,_ll_get_word_from_mp_limb_n)

/* lowlevels/vec.c */
#define ll_vec_add __C(R,_ll_vec_add)
#define ll_vec_neg __C(R,_ll_vec_neg)
#define ll_vec_add_mul __C(R,_ll_vec_add_mul)
#define ll_vec_add_mul_by_cte __C(R,_ll_vec_add_mul_by_cte)
#define ll_vec_clear __C(R,_ll_vec_clear)
#define ll_vec_cmp __C(R,_ll_vec_cmp)
#define ll_vec_copy __C(R,_ll_vec_copy)
#define ll_vec_true_size __C(R,_ll_vec_true_size)
#define ll_vec_free __C(R,_ll_vec_free)
#define ll_vec_hamming_weight __C(R,_ll_vec_hamming_weight)
#define ll_vec_hamming_distance __C(R,_ll_vec_hamming_distance)
#define ll_vec_init __C(R,_ll_vec_init)
#define ll_vec_init_random __C(R,_ll_vec_init_random)
#define ll_vec_iszero __C(R,_ll_vec_iszero)
#define ll_vec_malloc_copy __C(R,_ll_vec_malloc_copy)
#define ll_vec_malloc_init __C(R,_ll_vec_malloc_init)
#define ll_vec_malloc_random __C(R,_ll_vec_malloc_random)
#define ll_vec_mul_by_cte __C(R,_ll_vec_mul_by_cte)
#define ll_vec_print __C(R,_ll_vec_print)
#define ll_vec_random __C(R,_ll_vec_random)
#define ll_vec_random_hamming_weight __C(R,_ll_vec_random_hamming_weight)
#define ll_vec_realloc __C(R,_ll_vec_realloc)
#define ll_vec_sub __C(R,_ll_vec_sub)
#define ll_vec_sub_mul __C(R,_ll_vec_sub_mul)
#define ll_vec_sub_sub __C(R,_ll_vec_sub_sub)
#define ll_vec_zero __C(R,_ll_vec_zero)

/* lowlevels/upol_prod_affine.c */
#define ll_upol_prod_affine __C(R,_ll_upol_prod_affine)
#define ll_upol_prod_affine_neg __C(R,_ll_upol_prod_affine_neg)

/* lowlevels/dbpol_upol_map_XtoY.c */
#define ll_dbpol_upol_map_XtoY __C(R,_ll_dbpol_upol_map_XtoY)

/* lowlevels/binomial.c */
#define ll_binomial __C(R,_ll_binomial)

/* lowlevels/upol_discrepancy.c */
#define ll_upol_discrepancy __C(R,_ll_upol_discrepancy)

/* lowlevels/dbpol_discrepancy.c */
#define ll_dbpol_discrepancy __C(R,_ll_dbpol_discrepancy)

/* lowlevels/koetter_binomial.c */
#define ll_koetter_binomial_single __C(R,_ll_koetter_binomial_single)

/* lowlevels/upol_eval.c */
#define ll_upol_eval __C(R,_ll_upol_eval)
#define ll_upol_multi_eval __C(R,_ll_upol_multi_eval)

/* lowlevels/dbpol_eval.c */
#define ll_dbpol_eval __C(R,_ll_dbpol_eval)
#define ll_dbpol_eval_upol __C(R,_ll_dbpol_eval_upol)

/* lowlevels/upol_roots_fq.c */
#define ll_upol_roots_fq __C(R,_ll_upol_roots_fq)

/* lowlevels/upol_pow_mod.c */
#define ll_upol_pow_mod __C(R,_ll_upol_pow_mod)
#define ll_upol_pow_mod_uma __C(R,_ll_upol_pow_mod_uma)

/* lowlevels/upol_binpow_mod.c */
#define ll_upol_binpow_mod __C(R,_ll_upol_binpow_mod)

/* lowlevels/upol_derivative.c */
#define ll_upol_derivative_naive __C(R,_ll_upol_derivative_naive)
#define ll_upol_derivative __C(R,_ll_upol_derivative)

/* lowlevels/upol_eqdegsplit.c */
#define ll_upol_trace_poly __C(R,_ll_upol_trace_poly)
#define ll_upol_cantor_zassenhaus __C(R,_ll_upol_cantor_zassenhaus)
#define ll_upol_eqdegsplit __C(R,_ll_upol_eqdegsplit)

/* lowlevels/upol_eqdegfact.c */
#define ll_upol_eqdegfact __C(R,_ll_upol_eqdegfact)

/* decoding/lowlevels/upol.c */
#define ll_upol_iszero __C(R,_ll_upol_iszero)

/* decoding/lowlevels/upol_eea.c */
#define ll_upol_eea_naive __C(R,_ll_upol_eea_naive)
#define ll_upol_eea __C(R,_ll_upol_eea)

/* decoding/lowlevels/upol_partial_eea.c */
#define ll_upol_partial_eea_naive __C(R,_ll_upol_partial_eea_naive)
#define ll_upol_partial_eea __C(R,_ll_upol_partial_eea)

/* decoding/lowlevels/vec_prod.c */
#define ll_vec_prod_naive __C(R,_ll_vec_prod_naive)
#define ll_vec_prod __C(R,_ll_vec_prod)

/* decoding/lowlevels/upol_interpolation.c */
#define ll_upol_interpolation_naive __C(R,_ll_upol_interpolation_naive)
#define ll_upol_interpolation __C(R,_ll_upol_interpolation)

/* decoding/lowlevels/upol_mul_kronecker_char2_word.c */
#define ll_put_word_into_unsigned_long \
  __C(R,_ll_put_word_into_unsigned_long)
#define ll_get_word_from_unsigned_long_1 \
  __C(R,_ll_get_word_from_unsigned_long_1)
#define ll_upol_mul_kronecker_char2_word_encode \
  __C(R,_ll_upol_mul_kronecker_char2_word_encode)
#define ll_upol_mul_kronecker_char2_word_decode \
  __C(R,_ll_upol_mul_kronecker_char2_word_decode)
#define ll_upol_mul_kronecker_char2_word \
  __C(R,_ll_upol_mul_kronecker_char2_word)

/* decoding/lowlevels/upol_div_by_affine.c */
#define ll_upol_div_by_affine __C(R,_ll_upol_div_by_affine)

