/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/*************************

     static rings

*************************/

#define RING_NAME gfp_int
#define PRIME 101
#define WORD_TYPE unsigned int
#include <decoding/rings/gfp_word.c>
#include <decoding/algos.c>

#define RING_NAME gfp_long
#define PRIME 257
#define WORD_TYPE unsigned long
#include <decoding/rings/gfp_word.c>
#include <decoding/algos.c>

#define RING_NAME gf2n_short
#define EXT_DEGREE 8
#define WORD_TYPE unsigned short
#include <decoding/rings/gf2n_word.c>
#include <decoding/algos.c>

#define RING_NAME gf2n_int
#define EXT_DEGREE 8
#define WORD_TYPE unsigned int
#include <decoding/rings/gf2n_word.c>
#include <decoding/algos.c>

#define RING_NAME gf2n_long
#define EXT_DEGREE 8
#define WORD_TYPE unsigned long
#include <decoding/rings/gf2n_word.c>
#include <decoding/algos.c>

#define RING_NAME gfp_float
#define PRIME 101
#include <decoding/rings/gfp_float.c>
#include <decoding/algos.c>

#define RING_NAME gfp_double
#define PRIME 307
#include <decoding/rings/gfp_double.c>
#include <decoding/algos.c>


/*************************

     dynamic rings

*************************/

/*
#define RING_NAME gfp_dynamic_int
#define WORD_TYPE unsigned int
#include <decoding/rings/gfp_word_dynamic.c>
#include <decoding/algos.c>

#define RING_NAME gfp_dynamic_long
#define WORD_TYPE unsigned long
#include <decoding/rings/gfp_word_dynamic.c>
#include <decoding/algos.c>
*/

/*************************

   rings from external
        libraries

*************************/

/* these tests are done to see whether
   the wrapper for the external libraries
   work properly. The tests should be done
   within the external libraries too.
*/

#define RING_NAME mpfq_gf2_8
#define EXT_DEGREE 8
#include <decoding/rings/mpfq_gf2n_wrapper.c>
#include <decoding/algos.c>

