/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

void test_sudan(uma n,uma k,uma percent,uma max) {
  uma i,j,rad,tau,nc;
  vec m,y,e,*c;
  rs_code rs;
  fputs("Sudan algorithm over " __S(R) "...",stdout);
  fflush(stdout);
  vec_inits(m,y,e,NULL);
  rs_code_init_with_support(rs,n,k);
  rad = sudan_max_errors(n,k);
  tau = (uma)((double)percent * (double)rad / 100.0);
  for( i = 0 ; i < max ; i++ ) {
    rs_code_random_codeword(m,rs);
    vec_random_hamming_weight(e,n,tau);
    vec_add(y,m,e);
    nc = rs_code_sudan_koetter(&c,rs,y,tau);
    if ( nc == 0 ) {
      fputs("FAIL\n\nno codeword found\n",stdout);
      exit(-1);
    }
    for( j = 0 ; j < nc ; j++ ) {
      if ( vec_cmp(c[j],m) == 0 ) goto test_sudan_good;
    }
    fputs("FAIL\n\noriginal codeword not found in the list\n",stdout);
    exit(-1);
test_sudan_good:;
    vec_ptr_clear(c,nc);
  }
  rs_code_clear(rs);
  vec_clears(m,y,e,NULL);
  fputs("OK\n",stdout);
}

