##
This file is part of decoding
Copyright (C) 2012  Guillaume Quintin, INRIA

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
##

==NAME==

sudan - print Sudan list decoding parameters

==SYNOPSIS==

`sudan` `n` `k` [ `--all` | `--list-size` | `--max-errors` | \
`--max-errors` `e` ] ...

==DESCRIPTION==

Print Sudan list decoding algorithm parameters. By default
when invoked with the length of the code `n` and its
dimension `k` followed by `--all`, `sudan` prints all the
informations about the Sudan list decoding algorithm:
the unique decoding radius of the code, the maximum number
of errors that can be corrected and the list-size which
corresponds to the maximum number of codewords that can be
returned.

> `n`
  The length of the code.

> `k`
  The dimension of the code.

> `--all`
  Print all the information about the Sudan algorithm.

> `--max-errors`
  Only print the maximum number of errors that can be corrected
  by the Sudan algorithm. 
  
  It is useful when `sudan` is invoked
  within a shell script.

> `--list-size`
  If the number of expected errors is given with `--errors` print
  the list-size given that number of expected errors.

  Otherwise print the list-size corresponding to the
  maximum number of correctible errors.
  
  It is useful when `sudan` is invoked
  within a shell script.
  
> `--errors` `e`
  Indicate that one wants to correct `e` errors.

==EXEMPLES==

> `sudan 50 10 --all`
  Print all informations related to a [50,10] Reed-Solomon
  code to be decoded by the Sudan algorithm.

> `sudan 50 10 --errors 21 --all`
  Print all informations related to a [50,10] Reed-Solomon
  code to be decoded with an expected number of 21 errors
  by the Sudan algorithm.

> `sudan 50 10 --errors 21 --list-size`
  Print the list-size related to a [50,10] Reed-Solomon
  code to be decoded with an expected number of 21 errors
  by the Sudan algorithm.

==AUTHOR==

Written by Guillaume Quintin (quintin@lix.polytechnique.fr).

